"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantStudyMetadata(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "sampleSetType",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_9 import opencb as opencb_2_9_3
        from protocols.protocol_8_9 import opencb as opencb_2_9_3

        return {
            "aggregatedHeader": opencb_2_9_3.VariantFileHeader,
            "cohorts": opencb_2_9_3.Cohort,
            "files": opencb_2_9_3.VariantFileMetadata,
            "individuals": opencb_2_9_3.Individual,
            "stats": opencb_2_9_3.VariantStudyStats,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_9 import opencb as opencb_2_9_3
        from protocols.protocol_8_9 import opencb as opencb_2_9_3

        return {
            "aggregation": opencb_2_9_3.Aggregation,
            "sampleSetType": opencb_2_9_3.SampleSetType,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_9 import opencb as opencb_2_9_3
        from protocols.protocol_8_9 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.metadata.VariantFileHeader": opencb_2_9_3.VariantFileHeader,
            "org.opencb.biodata.models.variant.metadata.Aggregation": opencb_2_9_3.Aggregation,
            "org.opencb.biodata.models.metadata.Cohort": opencb_2_9_3.Cohort,
            "org.opencb.biodata.models.variant.metadata.VariantFileMetadata": opencb_2_9_3.VariantFileMetadata,
            "org.opencb.biodata.models.metadata.Individual": opencb_2_9_3.Individual,
            "org.opencb.biodata.models.metadata.SampleSetType": opencb_2_9_3.SampleSetType,
            "org.opencb.biodata.models.variant.metadata.VariantStudyStats": opencb_2_9_3.VariantStudyStats,
            "org.opencb.biodata.models.variant.metadata.VariantStudyMetadata": opencb_2_9_3.VariantStudyMetadata,
        }

    __slots__ = [
        "id",
        "sampleSetType",
        "aggregatedHeader",
        "aggregation",
        "attributes",
        "cohorts",
        "description",
        "files",
        "individuals",
        "stats",
    ]

    def __init__(
        self,
        id,
        sampleSetType,
        aggregatedHeader=None,
        aggregation="NONE",
        attributes=dict,
        cohorts=list,
        description=None,
        files=list,
        individuals=list,
        stats=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.VariantStudyMetadata model.

        :param id:
            Study id. Will match with the {@link
            org.opencb.biodata.models.variant.StudyEntry#getStudyId}
        :type id: str
        :param sampleSetType:
            Type of sample set. Defines the type of the study.
        :type sampleSetType: SampleSetType
        :param aggregatedHeader:
            Aggregation of all the file headers from this study
        :type aggregatedHeader: None | VariantFileHeader
        :param aggregation:
            Some studies does not provide real samples information. Instead, only
            aggregated data is provided as file attributes. This field
            represents the schema of representing aggregated data (if
            any)
        :type aggregation: Aggregation
        :param attributes:
            Other user defined attributes related with the study
        :type attributes: dict[str, str]
        :param cohorts:
            Metadata from with all the cohorts defined in this study
        :type cohorts: list[Cohort]
        :param description:
            Optional description
        :type description: None | str
        :param files:
            Metadata from all the files contained in this study
        :type files: list[VariantFileMetadata]
        :param individuals:
            Metadata from all the individuals and samples in this study
        :type individuals: list[Individual]
        :param stats:
            Samples and Cohort global statistics
        :type stats: None | VariantStudyStats
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
